searchNodes=[{"ref":"Dlex.html","title":"Dlex","type":"module","doc":"Dgraph driver for Elixir. This module handles the connection to Dgraph, providing pooling (via DBConnection), queries, mutations and transactions."},{"ref":"Dlex.html#alter/3","title":"Dlex.alter/3","type":"function","doc":"Alter dgraph schema Example iex&gt; Dlex.alter(conn, &quot;name: string @index(term) .&quot;) {:ok, &quot;&quot;} Options :timeout - Call timeout (default: 15000)"},{"ref":"Dlex.html#alter!/3","title":"Dlex.alter!/3","type":"function","doc":"Alter dgraph schema"},{"ref":"Dlex.html#child_spec/1","title":"Dlex.child_spec/1","type":"function","doc":"Supervisor callback. For available options, see: start_link/1."},{"ref":"Dlex.html#delete/2","title":"Dlex.delete/2","type":"function","doc":"The same as Dlex.delete(conn, &quot;&quot;, deletion, [])"},{"ref":"Dlex.html#delete/3","title":"Dlex.delete/3","type":"function","doc":"The same as Dlex.delete(conn, query, deletion, []) or Dlex.delete(conn, &quot;&quot;, deletion, opts)"},{"ref":"Dlex.html#delete/4","title":"Dlex.delete/4","type":"function","doc":"Send mutation to dgraph Options: return_json - if json with uids should be returned (default: false) Example of usage iex&gt; mutation = &quot; _:foo &lt;name&gt; &quot;Foo&quot; . _:foo &lt;owns&gt; _:bar . _:bar &lt;name&gt; &quot;Bar&quot; . &quot; iex&gt; Dlex.delete(conn, mutation) {:ok, %{&quot;bar&quot; =&gt; &quot;0xfe04c&quot;, &quot;foo&quot; =&gt; &quot;0xfe04b&quot;}} Using json iex&gt; json = %{&quot;name&quot; =&gt; &quot;Foo&quot;, &quot;owns&quot; =&gt; [%{&quot;name&quot; =&gt; &quot;Bar&quot;}]} Dlex.delete(conn, json) {:ok, %{&quot;blank-0&quot; =&gt; &quot;0xfe04d&quot;, &quot;blank-1&quot; =&gt; &quot;0xfe04e&quot;}} iex&gt; Dlex.delete(conn, json, return_json: true) {:ok, %{ &quot;name&quot; =&gt; &quot;Foo&quot;, &quot;owns&quot; =&gt; [%{&quot;name&quot; =&gt; &quot;Bar&quot;, &quot;uid&quot; =&gt; &quot;0xfe050&quot;}], &quot;uid&quot; =&gt; &quot;0xfe04f&quot; }} Options :timeout - Call timeout (default: 15000)"},{"ref":"Dlex.html#delete!/2","title":"Dlex.delete!/2","type":"function","doc":"Runs a mutation with delete target and returns the result or raises Dlex.Error if there was an error. See delete/2."},{"ref":"Dlex.html#delete!/3","title":"Dlex.delete!/3","type":"function","doc":"Runs a mutation with delete target and returns the result or raises Dlex.Error if there was an error. See delete/3."},{"ref":"Dlex.html#delete!/4","title":"Dlex.delete!/4","type":"function","doc":"Runs a mutation with delete target and returns the result or raises Dlex.Error if there was an error. See delete/4."},{"ref":"Dlex.html#mutate/2","title":"Dlex.mutate/2","type":"function","doc":"The same as Dlex.mutate(conn, &quot;&quot;, mutation, [])"},{"ref":"Dlex.html#mutate/3","title":"Dlex.mutate/3","type":"function","doc":"The same as Dlex.mutate(conn, query, mutation, []) or Dlex.mutate(conn, &quot;&quot;, mutation, opts)"},{"ref":"Dlex.html#mutate/4","title":"Dlex.mutate/4","type":"function","doc":"Send mutation to dgraph Options: return_json - if json with uids should be returned (default: false) Example of usage iex&gt; mutation = &quot; _:foo &lt;name&gt; &quot;Foo&quot; . _:foo &lt;owns&gt; _:bar . _:bar &lt;name&gt; &quot;Bar&quot; . &quot; iex&gt; Dlex.mutate(conn, mutation) {:ok, %{&quot;bar&quot; =&gt; &quot;0xfe04c&quot;, &quot;foo&quot; =&gt; &quot;0xfe04b&quot;}} Using json iex&gt; json = %{&quot;name&quot; =&gt; &quot;Foo&quot;, &quot;owns&quot; =&gt; [%{&quot;name&quot; =&gt; &quot;Bar&quot;}]} Dlex.mutate(conn, json) {:ok, %{&quot;blank-0&quot; =&gt; &quot;0xfe04d&quot;, &quot;blank-1&quot; =&gt; &quot;0xfe04e&quot;}} iex&gt; Dlex.mutate(conn, json, return_json: true) {:ok, %{ &quot;name&quot; =&gt; &quot;Foo&quot;, &quot;owns&quot; =&gt; [%{&quot;name&quot; =&gt; &quot;Bar&quot;, &quot;uid&quot; =&gt; &quot;0xfe050&quot;}], &quot;uid&quot; =&gt; &quot;0xfe04f&quot; }} Options :timeout - Call timeout (default: 15000)"},{"ref":"Dlex.html#mutate!/2","title":"Dlex.mutate!/2","type":"function","doc":"Runs a mutation and returns the result or raises Dlex.Error if there was an error. See mutate/2."},{"ref":"Dlex.html#mutate!/3","title":"Dlex.mutate!/3","type":"function","doc":"Runs a mutation and returns the result or raises Dlex.Error if there was an error. See mutate/3."},{"ref":"Dlex.html#mutate!/4","title":"Dlex.mutate!/4","type":"function","doc":"Runs a mutation and returns the result or raises Dlex.Error if there was an error. See mutate/4."},{"ref":"Dlex.html#query/4","title":"Dlex.query/4","type":"function","doc":"Send query to dgraph Example of usage iex&gt; query = &quot; query foo($a: string) { foo(func: eq(name, $a)) { uid expand(_all_) } } &quot; iex&gt; Dlex.query(conn, query, %{&quot;$a&quot; =&gt; &quot;Foo&quot;}) {:ok, %{&quot;foo&quot; =&gt; [%{&quot;name&quot; =&gt; &quot;Foo&quot;, &quot;uid&quot; =&gt; &quot;0xfe04d&quot;}]}}"},{"ref":"Dlex.html#query!/4","title":"Dlex.query!/4","type":"function","doc":"Runs a query and returns the result or raises Dlex.Error if there was an error. See query/3."},{"ref":"Dlex.html#query_schema/1","title":"Dlex.query_schema/1","type":"function","doc":"Query schema of dgraph"},{"ref":"Dlex.html#query_schema!/1","title":"Dlex.query_schema!/1","type":"function","doc":"Query schema of dgraph"},{"ref":"Dlex.html#set/3","title":"Dlex.set/3","type":"function","doc":"See mutate/3 for documentation."},{"ref":"Dlex.html#set!/3","title":"Dlex.set!/3","type":"function","doc":"See mutate!/3 for documentation."},{"ref":"Dlex.html#start_link/1","title":"Dlex.start_link/1","type":"function","doc":"Start dgraph connection process. Options :hostname - Server hostname (default: DGRAPH_HOST, than localhost) :port - Server port (default: DGRAPH_PORT env var, then 9080) :keepalive - Keepalive option for http client (default: :infinity) :json_library - Specifies json library to use (default: Jason) :transport - Specify if grpc or http should be used (default: grpc) :connect_timeout - Connection timeout in milliseconds (default: 15000); :timeout - Call timeout in milliseconds (default: 15000); SSL/TLS configuration (automaticly enabled, if required files provided) :cacertfile - Path to your CA certificate. Should be provided for SSL authentication :certfile - Path to client certificate. Should be additionally provided for TSL authentication :keyfile - Path to client key. Should be additionally provided for TSL authentication DBConnection options :backoff_min - The minimum backoff interval (default: 1_000) :backoff_max - The maximum backoff interval (default: 30_000) :backoff_type - The backoff strategy, :stop for no backoff and to stop, :exp for exponential, :rand for random and :rand_exp for random exponential (default: :rand_exp) :name - A name to register the started process (see the :name option in GenServer.start_link/3) :pool - Chooses the pool to be started :pool_size - Chooses the size of the pool :queue_target in microseconds, defaults to 50 :queue_interval in microseconds, defaults to 1000 Example of usage iex&gt; {:ok, conn} = Dlex.start_link() {:ok, #PID&lt;0.216.0&gt;}"},{"ref":"Dlex.html#transaction/3","title":"Dlex.transaction/3","type":"function","doc":"Execute serie of queries and mutations in a transactions"},{"ref":"Dlex.html#t:conn/0","title":"Dlex.conn/0","type":"type","doc":""},{"ref":"Dlex.html#t:uid/0","title":"Dlex.uid/0","type":"type","doc":""},{"ref":"Dlex.Adapter.html","title":"Dlex.Adapter","type":"behaviour","doc":""},{"ref":"Dlex.Adapter.html#__using__/1","title":"Dlex.Adapter.__using__/1","type":"macro","doc":"Use Dlex.Adapter to set the behaviour."},{"ref":"Dlex.Adapter.html#c:alter/4","title":"Dlex.Adapter.alter/4","type":"callback","doc":""},{"ref":"Dlex.Adapter.html#alter/5","title":"Dlex.Adapter.alter/5","type":"function","doc":""},{"ref":"Dlex.Adapter.html#c:commit_or_abort/4","title":"Dlex.Adapter.commit_or_abort/4","type":"callback","doc":""},{"ref":"Dlex.Adapter.html#commit_or_abort/5","title":"Dlex.Adapter.commit_or_abort/5","type":"function","doc":""},{"ref":"Dlex.Adapter.html#c:connect/3","title":"Dlex.Adapter.connect/3","type":"callback","doc":""},{"ref":"Dlex.Adapter.html#connect/4","title":"Dlex.Adapter.connect/4","type":"function","doc":""},{"ref":"Dlex.Adapter.html#c:disconnect/1","title":"Dlex.Adapter.disconnect/1","type":"callback","doc":""},{"ref":"Dlex.Adapter.html#disconnect/2","title":"Dlex.Adapter.disconnect/2","type":"function","doc":""},{"ref":"Dlex.Adapter.html#c:mutate/4","title":"Dlex.Adapter.mutate/4","type":"callback","doc":""},{"ref":"Dlex.Adapter.html#mutate/5","title":"Dlex.Adapter.mutate/5","type":"function","doc":""},{"ref":"Dlex.Adapter.html#c:ping/1","title":"Dlex.Adapter.ping/1","type":"callback","doc":""},{"ref":"Dlex.Adapter.html#ping/2","title":"Dlex.Adapter.ping/2","type":"function","doc":""},{"ref":"Dlex.Adapter.html#c:query/4","title":"Dlex.Adapter.query/4","type":"callback","doc":""},{"ref":"Dlex.Adapter.html#query/5","title":"Dlex.Adapter.query/5","type":"function","doc":""},{"ref":"Dlex.Adapter.html#t:conn/0","title":"Dlex.Adapter.conn/0","type":"type","doc":""},{"ref":"Dlex.Adapter.html#t:host/0","title":"Dlex.Adapter.host/0","type":"type","doc":""},{"ref":"Dlex.Adapter.html#t:json_lib/0","title":"Dlex.Adapter.json_lib/0","type":"type","doc":""},{"ref":"Dlex.Adapter.html#t:opts/0","title":"Dlex.Adapter.opts/0","type":"type","doc":""},{"ref":"Dlex.Adapter.html#t:port_number/0","title":"Dlex.Adapter.port_number/0","type":"type","doc":""},{"ref":"Dlex.Adapter.html#t:request/0","title":"Dlex.Adapter.request/0","type":"type","doc":""},{"ref":"Dlex.Adapter.html#t:result/0","title":"Dlex.Adapter.result/0","type":"type","doc":""},{"ref":"Dlex.Adapter.html#t:transaction/0","title":"Dlex.Adapter.transaction/0","type":"type","doc":""},{"ref":"Dlex.Adapters.GRPC.html","title":"Dlex.Adapters.GRPC","type":"module","doc":""},{"ref":"Dlex.Error.html","title":"Dlex.Error","type":"exception","doc":"Dgraph or connection error are wrapped in Dlex.Error."},{"ref":"Dlex.Error.html#t:t/0","title":"Dlex.Error.t/0","type":"type","doc":""},{"ref":"Dlex.Field.html","title":"Dlex.Field","type":"module","doc":""},{"ref":"Dlex.Field.html#t:t/0","title":"Dlex.Field.t/0","type":"type","doc":""},{"ref":"Dlex.Field.html#t:type/0","title":"Dlex.Field.type/0","type":"type","doc":""},{"ref":"Dlex.Node.html","title":"Dlex.Node","type":"module","doc":"Simple high level API for accessing graphs Usage defmodule Shared do use Dlex.Node shared do field :id, :string, index: [&quot;term&quot;] field :name, :string, index: [&quot;term&quot;] end end defmodule User do use Dlex.Node, depends_on: Shared schema &quot;user&quot; do field :id, :auto field :name, :auto end end defmodule User do use Dlex.Node schema &quot;user&quot; do field :id, :auto, depends_on: Shared field :name, :string, index: [&quot;term&quot;] field :age, :integer field :cache, :any, virtual: true field :owns, :uid end end Dgraph types: * `:integer` * `:float` * `:string` * `:geo` * `:datetime` * `:uid` * `:auto` - special type, which can be used for `depends_on` Reflection Any schema module will generate the __schema__ function that can be used for runtime introspection of the schema: __schema__(:source) - Returns the source as given to schema/2; __schema__(:fields) - Returns a list of all non-virtual field names; __schema__(:alter) - Returns a generated alter schema __schema__(:field, field) - Returns the name of field in database for field in a struct and vice versa; __schema__(:type, field) - Returns the type of the given non-virtual field; Additionally it generates Ecto compatible __changeset__ for using with Ecto.Changeset."},{"ref":"Dlex.Node.html#field/3","title":"Dlex.Node.field/3","type":"macro","doc":""},{"ref":"Dlex.Node.html#schema/2","title":"Dlex.Node.schema/2","type":"macro","doc":""},{"ref":"Dlex.Node.html#shared/1","title":"Dlex.Node.shared/1","type":"macro","doc":""},{"ref":"Dlex.Repo.html","title":"Dlex.Repo","type":"module","doc":"Ecto-like repository, which allows to embed the schema defmodule Repo do use Dlex.Repo, otp_app: :my_app, modules: [User] end config :my_app, Repo, hostname: &quot;localhost&quot;, port: 3306"},{"ref":"Dlex.Repo.html#__using__/1","title":"Dlex.Repo.__using__/1","type":"macro","doc":""},{"ref":"Dlex.Repo.html#all/2","title":"Dlex.Repo.all/2","type":"function","doc":"Query all"},{"ref":"Dlex.Repo.html#alter_schema/2","title":"Dlex.Repo.alter_schema/2","type":"function","doc":"Alter schema for modules"},{"ref":"Dlex.Repo.html#build_lookup_map/2","title":"Dlex.Repo.build_lookup_map/2","type":"function","doc":"Build or update lookup map from module list"},{"ref":"Dlex.Repo.html#encode/1","title":"Dlex.Repo.encode/1","type":"function","doc":""},{"ref":"Dlex.Repo.html#field/2","title":"Dlex.Repo.field/2","type":"function","doc":""},{"ref":"Dlex.Repo.html#get/3","title":"Dlex.Repo.get/3","type":"function","doc":"Get by uid"},{"ref":"Dlex.Repo.html#get!/3","title":"Dlex.Repo.get!/3","type":"function","doc":"The same as get/3, but return result or raises."},{"ref":"Dlex.Repo.html#get_by/3","title":"Dlex.Repo.get_by/3","type":"function","doc":""},{"ref":"Dlex.Repo.html#mutate/3","title":"Dlex.Repo.mutate/3","type":"function","doc":"Mutate data"},{"ref":"Dlex.Repo.html#mutate!/3","title":"Dlex.Repo.mutate!/3","type":"function","doc":"The same as mutate/2, but return result of sucessful operation or raises."},{"ref":"Dlex.Repo.html#set/3","title":"Dlex.Repo.set/3","type":"function","doc":"The same as mutate."},{"ref":"Dlex.Repo.html#set!/3","title":"Dlex.Repo.set!/3","type":"function","doc":"The same as mutate!."},{"ref":"Dlex.Repo.html#snapshot/1","title":"Dlex.Repo.snapshot/1","type":"function","doc":"Generate snapshot for running meta process"},{"ref":"Dlex.Repo.html#source/1","title":"Dlex.Repo.source/1","type":"function","doc":""},{"ref":"Dlex.Repo.Meta.html","title":"Dlex.Repo.Meta","type":"module","doc":"Meta holder for repository."},{"ref":"Dlex.Repo.Meta.html#child_spec/1","title":"Dlex.Repo.Meta.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Dlex.Repo.Meta.html#get/1","title":"Dlex.Repo.Meta.get/1","type":"function","doc":"Get saved meta information for the repo"},{"ref":"Dlex.Repo.Meta.html#register/2","title":"Dlex.Repo.Meta.register/2","type":"function","doc":"Register name and modules"},{"ref":"Dlex.Utils.html","title":"Dlex.Utils","type":"module","doc":""},{"ref":"Dlex.Utils.html#add_blank_ids/2","title":"Dlex.Utils.add_blank_ids/2","type":"function","doc":"Add temporary blank ids to json object"},{"ref":"Dlex.Utils.html#replace_ids/3","title":"Dlex.Utils.replace_ids/3","type":"function","doc":"Replace temporary blank ids to real ids"}]